# Modern Dev – Dieses Python-Projekt enthält mehrere Hauptfunktionen:

## RomanConverter
Konvertiert römische Zahlen in Dezimalzahlen.

## Counter
Zählt die Anzahl der Buchstaben `E` und `D` in einem gegebenen String (case-insensitive).

## Calculator
Führt einfache mathematische Berechnungen durch.

## StringCalculator
Addiert Zahlen aus einem String mit Unterstützung für:
- Kommas und Zeilenumbrüche als Trennzeichen
- Benutzerdefinierte Delimiter (`//;\n1;2`)
- Mehrzeichen-Delimiter (`//[***]\n1***2***3`)
- Fehler bei negativen Zahlen (mit Auflistung)
- Ignoriert Zahlen > 1000

## Übersicht
Dieses Python-Projekt enthält zwei Hauptfunktionen:

1. **RomanConverter**: Konvertiert römische Zahlen in Dezimalzahlen.
2. **Counter**: Zählt die Anzahl der Buchstaben `E` und `D` in einem gegebenen String (case-insensitive).
3. **Calculator**: Führt einfache mathematische Berechnungen durch.
4. **StringCalculator**: Addiert Zahlen aus einem String mit Unterstützung für:
   - Kommas und Zeilenumbrüche als Trennzeichen
   - Benutzerdefinierte Delimiter (`//;\n1;2`)
   - Mehrzeichen-Delimiter (`//[***]\n1***2***3`)
   - Fehler bei negativen Zahlen (mit Auflistung)
   - Ignoriert Zahlen > 1000

## Installation & Nutzung

### 1. Virtuelle Umgebung erstellen
```bash
python -m venv .venv
source .venv/bin/activate  # macOS/Linux
# .venv\Scripts\activate    # Windows

pip install -r requirements.txt

python src/roman_converter.py

python src/Count_ED.py

python -m unittest discover -s tests

deactivate
```

### 2. StringCalculator 

Der `StringCalculator` wird über Unittests genutzt und entwickelt (Test-Driven Development).
Um ihn zu testen:

```bash
python -m unittest discover -s tests
deactivate
```

