from src.interfaces import IStringCalculator3


class StringCalculator(IStringCalculator3):
    def add(self, numbers: str) -> int:
        if not numbers:
            return 0

        # Überprüfe, ob ein benutzerdefiniertes Trennzeichen angegeben ist
        if numbers.startswith("//"):
            delimiter_line_end = numbers.find("\n")
            delimiter = numbers[2:delimiter_line_end]  # Extrahiere das Trennzeichen
            numbers = numbers[delimiter_line_end + 1:]  # Entferne die erste Zeile mit dem Trennzeichen

        else:
            delimiter = ','  # Standard-Trennzeichen ist Komma, wenn keine Zeile mit dem Trennzeichen vorhanden ist

        # Ersetze alle Vorkommen des Trennzeichens und teile die Eingabe
        numbers = numbers.replace("\n", delimiter)
        nums = numbers.split(delimiter)

        # Filtere alle Zahlen, die größer als 1000 sind
        nums = [int(num) for num in nums if int(num) <= 1000]

        # Prüfe auf negative Zahlen
        negatives = [num for num in nums if num < 0]

        if negatives:
            # Wenn negative Zahlen vorhanden sind, werfe eine Ausnahme
            raise ValueError(f"Negatives not allowed: {', '.join(map(str, negatives))}")

        # Berechne die Summe der Zahlen, die <= 1000 sind
        return sum(nums)