from src.interfaces import IConverter


class RomanConverter(IConverter):
    def convert(self, num: int) -> str:

        '''Sicherstellen, dass nur eine ganze Zahl eingegeben wurde.'''
        if isinstance(num, str) and len(num.split(',')) > 1: 
            return 'Bitte nur eine ganze Zahl eingeben'
        
        roman_numbers = [(1000, 'M'), (500, 'D'), (100, 'C'), (90, 'XC'), (50, 'L'), (40, 'XL'), (10, 'X'), (9, 'IX'), (5, 'V'), (4, 'IV'), (1, 'I')]
        
        roman_str = ''

        '''Wenn eine 0 eingegeben wird muss eine Exception folgen'''
        if num == 0:
            return "Es gibt keine römische Null"
        

        '''Sicherstellen, dass keine Zeichen oder Strings eingegeben werden'''
        if isinstance(num, int):

            '''Sicherstellen, dass keine negativen Zahlen eingegeben werden'''
            if num < 0:
                return "Es sind nur positive Zahlen zum konvertieren erlaubt"
            
            for value, numeral in roman_numbers:

                while num >= value:
                    roman_str += numeral
                    num -= value

            return roman_str
        else: 
            return "Bitte ganze Zahlen eingeben"