
import unittest
from src.interfaces import IStringCalculator4

class StringCalculator(IStringCalculator4):
    def add(self, numbers: str) -> int: 

        '''Leere Eingabe soll 0 ausgeben'''
        if numbers == "":
            return 0
        
        '''Standard-Trennzeichen'''
        delimiter = ";"
        
        '''Es wird geprüft ob ein benutzerdefiniertes Trennzeichen vorhanden ist.'''
        if numbers.startswith("//"):
            sep = numbers.split("\n", 1) 
            delimiter_sep = sep[0][2:]

            '''Für den Fall, dass das Trennzeichen in eckigen Klammern steht werden die Klammern entfernt und das Trennzeichen gespeichert'''
            if delimiter_sep.startswith("[") and delimiter_sep.endswith("]"):
                delimiter = delimiter_sep[1:-1]

            else:
                delimiter = delimiter_sep[0]

            '''Entfernen der ersten Zeile, damit nur noch Zahlen übrig bleiben'''
            numbers = sep[1]

        '''Ersetzen von Zeilenumbrüchen mit Delimiter und ersetzen von Delimiter durch ",", um splitten zu können'''
        numbers = numbers.replace("\n", delimiter).replace(delimiter, ",")

        list = numbers.split(",")
        result = 0
        
        negative_numbers = []

        for num in list:
            num = num.strip()
            if num == "":
                continue

            '''Sicherstellen dass Floats nicht berücksichtigt werden'''
            if "." in num:
                return "only integers allowed"
            
            '''Sicherstellen, dass keine Buchstaben verwendet werden dürfen'''
            try:
                number = int(num)
            except ValueError:
                return "only integers allowed"

            '''Konvertirung von Strings zu Integer'''
            if number < 0:
                negative_numbers.append(number)
            
            if number > 1000:
                continue
        
            result += number
        
        if len(negative_numbers) > 1:
            return "negatives not allowed " + str(negative_numbers)
        elif negative_numbers:
            return "negatives not allowed"

        return result