from src.interfaces import IStringCalculator2

class StringCalculator(IStringCalculator2):
    def add(self, numbers: str) -> int:
        if not numbers:
            return 0

        # Benutzerdefiniertes Trennzeichen
        if numbers.startswith("//"):
            if "\n" not in numbers:
                raise ValueError("Ungültiges Format: Nicht vollständig")
            delimiter_end_index = numbers.index("\n")
            delimiter_part = numbers[2:delimiter_end_index]
            if delimiter_part.startswith("[") and delimiter_part.endswith("]"):
                delimiter = delimiter_part[1:-1]
            else:
                delimiter = delimiter_part
            numbers = numbers[delimiter_end_index + 1:]
            numbers = numbers.replace(delimiter, ",")

        # Neue Zeilen durch Komma ersetzen
        numbers = numbers.replace("\n", ",")

        try:
            numbers_list = list(map(int, numbers.split(",")))
        except ValueError:
            raise ValueError("Ungültiges Zahlenformat: Enthält nicht-numerische Werte")

        # Negative Zahlen behandeln
        negative_numbers = [num for num in numbers_list if num < 0]
        if negative_numbers:
            raise ValueError(f"Negative nicht erlaubt: {negative_numbers}")

        # Zahlen über 1000 ignorieren
        numbers_list = [num for num in numbers_list if num <= 1000]

        return sum(numbers_list)