from src.interfaces import IStringCalculator5


class StringCalculator(IStringCalculator5):
    def add(self, numbers:str) -> int:
        if numbers == "":
            return 0
        
        #Prüfen, ob ein benutzerdefiniertes Trennzeichen definiert wurde

        if numbers.startswith("//"):
            delimiter_end_index = numbers.index("\n") #Zeilenumbruchs Position finden
            delimiter = numbers[2:delimiter_end_index] # Trennzeichen, also alles zwischen "//" und "\n" extrahieren

            if delimiter.startswith("[") and delimiter.endswith("]"):
                delimiter = delimiter[1:-1] # "[" und "]" entfernen

            numbers = numbers[delimiter_end_index + 1:] #Zahlen nach "\n" extrahieren
            numbers = numbers.replace(delimiter,",") #Benutzerdefiniertes Trennzeichen durch "," ersetzen

        #Zeilenumbrüche ebenfals durch "," ersetzen
        numbers = numbers.replace("\n",",")

        # String anhand von Kommas splitten, eine Liste der einzelnen Zahlen(in str) erzeugen und in Int umwandeln -> Ergebnis wäre z.B. bei add("1\n2,3,4") -> [1,2,3,4]
        num_list = list(map(int, numbers.split(",",)))

        #Prüfung auf negative Zahlen
        negatives = [n for n in num_list if n<0]
        if negatives:
            raise ValueError(f"negatives not allowed: {','.join(map(str, negatives))}") #Alle negativen Zahlen durch Kommas in getrennte Strings darstellen
        
        #Zahlen größer als 1000 aus Liste entfernen
        num_list = [n for n in num_list if n <= 1000]

        return sum(num_list) #Summe berechnen (bei einer Zahln wird immernoch dieselbe Zahl ausgegeben)