import unittest
#from src.Daniel.roman_converter_Daniel import RomanConverter
from src.my.roman_converter import RomanConverter


class TestConverter(unittest.TestCase):
    def setUp(self):
        self.c = RomanConverter()

    def test_convertOne(self):
        res = self.c.convert(1)
        self.assertEqual(res, 'I')

    def test_convertTwo(self):
        res = self.c.convert(2)
        self.assertEqual(res, 'II')

    def test_convertThree(self):
        res = self.c.convert(3)
        self.assertEqual(res, 'III')

    def test_convertFour(self):
        res = self.c.convert(4)
        self.assertEqual(res, 'IV')

    def test_convertFive(self):
        res = self.c.convert(5)
        self.assertEqual(res, 'V')

    def test_convertNine(self):
        res = self.c.convert(9)
        self.assertEqual(res, 'IX')

    def test_convertTen(self):
        res = self.c.convert(10)
        self.assertEqual(res, 'X')

    def test_convertTwentyTwo(self):
        res = self.c.convert(21)
        self.assertEqual(res, 'XXI')

    def test_convertFifty(self):
        res = self.c.convert(50)
        self.assertEqual(res, 'L')

    def test_convertHundred(self):
        res = self.c.convert(100)
        self.assertEqual(res, 'C')

    def test_convertFiveHundred(self):
        res = self.c.convert(500)
        self.assertEqual(res, 'D')

    def test_convertThousand(self):
        res = self.c.convert(1000)
        self.assertEqual(res, 'M')

    def test_convertFourDigit(self):
        res = self.c.convert(1111)
        self.assertEqual(res, 'MCXI')

    def test_convertNintyNine(self):
        res = self.c.convert(99)
        self.assertEqual(res, 'XCIX')

    def test_convertZero(self):
        res = self.c.convert(0)
        self.assertEqual(res, 'Es gibt keine römische Null')

    def test_convertFourty(self):
        res = self.c.convert(40)
        self.assertEqual(res, 'XL')

    def test_convertString(self):
        res = self.c.convert('HUIHIN')
        self.assertEqual(res, "Bitte ganze Zahlen eingeben")

    def test_convertFloat(self):
        res = self.c.convert(4.3)
        self.assertEqual(res, "Bitte ganze Zahlen eingeben")

    def test_convertNegative(self):
        res = self.c.convert(-4)
        self.assertEqual(res, "Es sind nur positive Zahlen zum konvertieren erlaubt")

    def test_convertYear(self):
        res = self.c.convert(2025)
        self.assertEqual(res, "MMXXV")

    def test_convertSign(self):
        res = self.c.convert('!')
        self.assertEqual(res, "Bitte ganze Zahlen eingeben")

    def test_convertMultipleNum(self):
        res = self.c.convert('4, 3')
        self.assertEqual(res, "Bitte nur eine ganze Zahl eingeben")

    def test_convertHighNum(self):
        res = self.c.convert(4000)
        self.assertEqual(res, "MMMM")

    def test_convertThirty(self):
        res = self.c.convert(30)
        self.assertEqual(res, "XXX")

    def test_convertNinety(self):
        res = self.c.convert(90)
        self.assertEqual(res, "XC")

    def test_convertEmpty(self):
        res = self.c.convert('')
        self.assertEqual(res, "Bitte ganze Zahlen eingeben")


if __name__ == "__main__":
    unittest.main()