import unittest
#from src.Lasse.roman_converter_Lasse import RomanConverter
from src.my.roman_converter import RomanConverter


class TestRomanConverter(unittest.TestCase):
    def setUp(self):
        self.converter = RomanConverter()

    def test_to_roman_basic(self):
        self.assertEqual(self.converter.convert(1), "I")
        self.assertEqual(self.converter.convert(5), "V")
        self.assertEqual(self.converter.convert(10), "X")
        self.assertEqual(self.converter.convert(50), "L")
        self.assertEqual(self.converter.convert(100), "C")
        self.assertEqual(self.converter.convert(500), "D")
        self.assertEqual(self.converter.convert(1000), "M")

    def test_to_roman_subtraction(self):
        self.assertEqual(self.converter.convert(4), "IV")
        self.assertEqual(self.converter.convert(9), "IX")
        self.assertEqual(self.converter.convert(40), "XL")
        self.assertEqual(self.converter.convert(90), "XC")
        self.assertEqual(self.converter.convert(400), "CD")
        self.assertEqual(self.converter.convert(900), "CM")

    def test_to_roman_addition(self):
        self.assertEqual(self.converter.convert(2), "II")
        self.assertEqual(self.converter.convert(3), "III")
        self.assertEqual(self.converter.convert(6), "VI")
        self.assertEqual(self.converter.convert(8), "VIII")
        self.assertEqual(self.converter.convert(30), "XXX")
        self.assertEqual(self.converter.convert(80), "LXXX")

    def test_to_roman_mixed(self):
        self.assertEqual(self.converter.convert(14), "XIV")
        self.assertEqual(self.converter.convert(19), "XIX")
        self.assertEqual(self.converter.convert(29), "XXIX")
        self.assertEqual(self.converter.convert(44), "XLIV")
        self.assertEqual(self.converter.convert(99), "XCIX")
        self.assertEqual(self.converter.convert(444), "CDXLIV")
        self.assertEqual(self.converter.convert(999), "CMXCIX")

    def test_to_roman_large_numbers(self):
        self.assertEqual(self.converter.convert(1001), "MI")
        self.assertEqual(self.converter.convert(1987), "MCMLXXXVII")
        self.assertEqual(self.converter.convert(2023), "MMXXIII")
        self.assertEqual(self.converter.convert(3999), "MMMCMXCIX")

    def test_to_roman_invalid(self):
        with self.assertRaises(ValueError):
            self.converter.convert(0)
        with self.assertRaises(ValueError):
            self.converter.convert(-1)
        with self.assertRaises(ValueError):
            self.converter.convert(4000)
        with self.assertRaises(ValueError):
            self.converter.convert("ABC")
        with self.assertRaises(ValueError):
            self.converter.convert(None)
        with self.assertRaises(ValueError):
            self.converter.convert(3.14)


if __name__ == "__main__":
    unittest.main()