import unittest
#from src.Muhamed.string_calculator_Muhamed import StringCalculator
from src.my.string_calculator import StringCalculator


class TestStingCalculator(unittest.TestCase):
    def setUp(self):
        self.calculator = StringCalculator()
    def test_empty_string(self):
        self.assertEqual(self.calculator.add(""), 0) #leerer string + 0
    def test_single_number(self):
        self.assertEqual(self.calculator.add("5"),5) #eingabe von einem String
    def test_multiple_numbers(self):
        self.assertEqual(self.calculator.add("5,5"),10)#eingabe mehrere strings
    def test_unknowen_amount_of_numbers(self):
        self.assertEqual(self.calculator.add("1,2,3"),6)
        self.assertEqual(self.calculator.add("10,20,30,40"),100)
        self.assertEqual(self.calculator.add("1,2,3,4,5,6"),21)
    def test_numbers_seperated_by_newline(self):
        self.assertEqual(self.calculator.add("1\n2"),3)
        self.assertEqual(self.calculator.add("1\n2\n3"),6)
        self.assertEqual(self.calculator.add("10,20\n30"),60)

    def test_negative_number_exception(self):

        with self.assertRaises(ValueError) as e:
            self.calculator.add("-1,2")
        self.assertEqual(str(e.exception), "negatives not allowed: -1")
    def test_multiple_negative_numbers_exception(self):
        with self.assertRaises(ValueError)as e:
            self.calculator.add("-1,-2,3")
        self.assertEqual(str(e.exception),"negatives not allowed: -1,-2")
        with self.assertRaises(ValueError) as e:
            self.calculator.add("-1,-3,4")
        self.assertEqual(str(e.exception),"negatives not allowed: -1,-3")

        with self.assertRaises(ValueError) as e:
            self.calculator.add("-1\n-3,4")
        self.assertEqual(str(e.exception),"negatives not allowed: -1,-3")
    def test_add_numbers_with_custom_delimiter(self):
        self.assertEqual(self.calculator.add("//;\n1;2;3"),6)
        self.assertEqual(self.calculator.add("//;\n1,2,3"),6)
        with self.assertRaises(ValueError) as e:
            self.calculator.add("//;\n-3,4")
        self.assertEqual(str(e.exception),"negatives not allowed: -3")

    def test_add_numbers_greater_than_1000(self):
        self.assertEqual(self.calculator.add("1,1001,2,3"),6)
    def test_add_numbers_greater_than_1000_1002(self):
        self.assertEqual(self.calculator.add("1002,1,2,3"),6)
    def test_add_numbers_greater_1000_and_minus(self):
        with self.assertRaises(ValueError) as e:
            self.calculator.add("//;\n-3,4;1001")
        self.assertEqual(str(e.exception),"negatives not allowed: -3")
    def test_custom_delimiter(self):
        self.assertEqual(self.calculator.add("//[***]\n1***2***3"),6)
    def test_custom_del(self):
        self.assertEqual(self.calculator.add("//[+++]\n1+++2+++3"),6)
    def test_custom_del2(self):
        self.assertEqual(self.calculator.add("//[aa]\n1aa2aa3"),6)



if __name__=='__main__':
    unittest.main()