import unittest
#from src.Wasilios.string_calculator_Wasilios import StringCalculator
from src.my.string_calculator import StringCalculator


class TestStringCalculator(unittest.TestCase):
    def test_add_empty(self):
        c = StringCalculator()
        self.assertEqual(c.add(""), 0)

    def test_add_one_string(self):
        c = StringCalculator()
        self.assertEqual(c.add("1"), 1)

    def test_add_two_string(self):
        c = StringCalculator()
        self.assertEqual(c.add("1,2"), 3)

    def test_add_multiple_string(self):
        c = StringCalculator()
        self.assertEqual(c.add("1,2,3,4,5,6,7"), 28)

    def test_add_new_lines(self):
        c = StringCalculator()
        self.assertEqual(c.add("1\n2,3,4"), 10)

    def test_add_exception(self):
        c = StringCalculator()
        with self.assertRaises(ValueError) as context:
            c.add("-5")
        self.assertEqual(str(context.exception), "negatives not allowed: -5")

    def test_add_negative_numbers(self):
        c = StringCalculator()
        with self.assertRaises(ValueError) as context:
            c.add("-5,-2,-2")
        self.assertEqual(str(context.exception), "negatives not allowed: -5,-2,-2")

    def test_add_different_delimiters(self):
        c = StringCalculator()
        self.assertEqual(c.add("//;\n1;2"), 3)

    def test_add_numbers_greater_than_1000(self):
        c = StringCalculator()
        self.assertEqual(c.add("2,1001"), 2)
        self.assertEqual(c.add("2,10022\n6"), 8)

    def test_delimiters_of_any_length(self):
        c = StringCalculator()
        self.assertEqual(c.add("//[***]\n1***2***3"), 6)

    def test_delimiters_of_any_length2(self):
        c = StringCalculator()
        self.assertEqual(c.add("//[*+*+*]\n1*+*+*2*+*+*3*+*+*220"), 226)


if __name__ == "__main__":
    unittest.main()
